Index: /java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- /java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 692)
+++ /java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 693)
@@ -199,4 +199,9 @@
 		<element name="bboxCenter" type="XYZ" flags="1"/>
 		<element name="bboxSize" type="XYZ" flags="3"/>
+		<element name="bboxGroundOffset" type="float" flags="3">
+			<description><![CDATA[Due to multiple modes of simulation and Part shapes, you need to add this value to the intended creature bottom elevation to get the 'z' coordinate of the bboxLow that places the creature exactly on the specific height level.
+Example:
+creature.locationSetBboxLow(10,10,0+creature.bboxGroundOffset); //bottom of the crearture will be at level 0 on a flat ground]]></description>
+		</element>
 		<element name="centerOfGravity" type="XYZ" flags="3">
 			<description><![CDATA[Only updated once every 'perfperiod' steps!]]></description>
@@ -1095,7 +1100,7 @@
 		</element>
 		<element name="getSimplest" function="true" type="Geno" flags="34">
-			<description><![CDATA[returns the simplest genotype for a given encoding (format). 0 means f0, 4 means f4, etc.]]></description>
-			<arguments>
-				<argument name="format" type="integer"/>
+			<description><![CDATA[returns the simplest genotype for a given encoding (format). "0" means f0, "4" means f4, etc.]]></description>
+			<arguments>
+				<argument name="format" type="string"/>
 			</arguments>
 		</element>
@@ -1553,4 +1558,8 @@
 			<description><![CDATA[mutation: probability of changing a node]]></description>
 		</element>
+		<element name="f4_mut_exmod" type="string" max="30">
+			<description><![CDATA[Modifiers that will not be added nor deleted during mutation
+(all: LlRrCcQqFfMmIiEeWwAaSs)]]></description>
+		</element>
 		<element name="f9_mut" type="float" min="0" max="1" default="0.1">
 			<description><![CDATA[How many genes should be mutated during single mutation (1=all genes, 0.1=ten percent)]]></description>
@@ -1679,5 +1688,6 @@
 		</element>
 		<element name="simi" type="float" flags="3">
-			<description><![CDATA[Read about details:
+			<description><![CDATA[Average of (1+dissimilarity(thisgeno,othergeno)) calculated for all other Genotype instances. This property is meant as fitness multiplier, included in the fitness function when similarity speciation (ExpProperties.cr_simi) is enabled.
+Read about details of dissimilarity calculation and its applications:
 http://www.framsticks.com/bib/Komosinski-et-al-2001
 http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
@@ -2230,5 +2240,5 @@
 	</type>
 	<type name="ModelSymmetry" context="Global context">
-<description><![CDATA[Calculates bilateral symmetry. Details are described in http://www.framsticks.com/bib/Komosinski-and-Jaskowski-2008]]></description>
+<description><![CDATA[Calculates bilateral symmetry. Details are described in http://www.framsticks.com/bib/Jaskowski-and-Komosinski-2008]]></description>
 		<element name="calculateSymmetry" function="true" type="float" flags="32">
 			<description><![CDATA[Returns bilateral symmetry (0.0 .. 1.0) for a given Model using default precision parameters (symPosSteps,symAlphaSteps,symBetaSteps). Returns the symmetry plane, too (sets symResultA,B,C,D).
@@ -3251,4 +3261,5 @@
 		</element>
 		<element name="povex_dust" type="integer" min="0" max="1" default="1"/>
+		<element name="povex_energy" type="integer" min="0" max="1" default="1"/>
 		<element name="povex_enable" function="true" flags="8"/>
 		<element name="povex_disable" function="true" flags="8"/>
@@ -3568,10 +3579,15 @@
 		</element>
 		<element name="wrldmap" type="string">
-			<description><![CDATA[Description of the world (Type: Blocks or Heighfield). Enter
-   r <sizex> <sizey> [seed]
-to generate a random landscape, or
-   m <sizex> <sizey> digits
-   M <sizex> <sizey> numbers
-to provide height values.
+			<description><![CDATA[Description of the world (only applies to world types: "Blocks" or "Height field").
+To generate a random landscape, use:
+   r[scaling] <sizex> <sizey> [seed]
+To generate a custom landscape, provide height values:
+   m[scaling] <sizex> <sizey> digits...
+ or
+   M[scaling] <sizex> <sizey> numbers...
+
+"digits..." is a sequence of integer values 0,1,2,..,9. You may also use '-' and '|' characters for smooth slides between blocks.
+"numbers..." is a sequence of floating point values, so the "M" option provides more freedom.
+[scaling] is an optional linear scaling expression in the form of *FACTOR+OFFSET or *FACTOR-OFFSET, for example "r*0.1-2 5 5" creates a 5x5 random map with a 10% amplitude, shifted down by 2.
 
 See also the WorldMap object.]]></description>
@@ -3707,7 +3723,7 @@
 		</element>
 		<element name="getSimplest" function="true" type="Geno" flags="34">
-			<description><![CDATA[returns the simplest genotype for a given encoding (format). 0 means f0, 4 means f4, etc.]]></description>
-			<arguments>
-				<argument name="format" type="integer"/>
+			<description><![CDATA[returns the simplest genotype for a given encoding (format). "0" means f0, "4" means f4, etc.]]></description>
+			<arguments>
+				<argument name="format" type="string"/>
 			</arguments>
 		</element>
@@ -4157,4 +4173,8 @@
 		<element name="f4_mut_mod" type="float" min="0" max="100" default="30.0">
 			<description><![CDATA[mutation: probability of changing a node]]></description>
+		</element>
+		<element name="f4_mut_exmod" type="string" max="30">
+			<description><![CDATA[Modifiers that will not be added nor deleted during mutation
+(all: LlRrCcQqFfMmIiEeWwAaSs)]]></description>
 		</element>
 		<element name="f9_mut" type="float" min="0" max="1" default="0.1">
@@ -5233,10 +5253,15 @@
 		</element>
 		<element name="wrldmap" type="string">
-			<description><![CDATA[Description of the world (Type: Blocks or Heighfield). Enter
-   r <sizex> <sizey> [seed]
-to generate a random landscape, or
-   m <sizex> <sizey> digits
-   M <sizex> <sizey> numbers
-to provide height values.
+			<description><![CDATA[Description of the world (only applies to world types: "Blocks" or "Height field").
+To generate a random landscape, use:
+   r[scaling] <sizex> <sizey> [seed]
+To generate a custom landscape, provide height values:
+   m[scaling] <sizex> <sizey> digits...
+ or
+   M[scaling] <sizex> <sizey> numbers...
+
+"digits..." is a sequence of integer values 0,1,2,..,9. You may also use '-' and '|' characters for smooth slides between blocks.
+"numbers..." is a sequence of floating point values, so the "M" option provides more freedom.
+[scaling] is an optional linear scaling expression in the form of *FACTOR+OFFSET or *FACTOR-OFFSET, for example "r*0.1-2 5 5" creates a 5x5 random map with a 10% amplitude, shifted down by 2.
 
 See also the WorldMap object.]]></description>
@@ -5609,5 +5634,6 @@
 		</element>
 		<element name="simi" type="float" flags="3">
-			<description><![CDATA[Read about details:
+			<description><![CDATA[Average of (1+dissimilarity(thisgeno,othergeno)) calculated for all other Genotype instances. This property is meant as fitness multiplier, included in the fitness function when similarity speciation (ExpProperties.cr_simi) is enabled.
+Read about details of dissimilarity calculation and its applications:
 http://www.framsticks.com/bib/Komosinski-et-al-2001
 http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
@@ -5807,4 +5833,9 @@
 		<element name="bboxCenter" type="XYZ" flags="1"/>
 		<element name="bboxSize" type="XYZ" flags="3"/>
+		<element name="bboxGroundOffset" type="float" flags="3">
+			<description><![CDATA[Due to multiple modes of simulation and Part shapes, you need to add this value to the intended creature bottom elevation to get the 'z' coordinate of the bboxLow that places the creature exactly on the specific height level.
+Example:
+creature.locationSetBboxLow(10,10,0+creature.bboxGroundOffset); //bottom of the crearture will be at level 0 on a flat ground]]></description>
+		</element>
 		<element name="centerOfGravity" type="XYZ" flags="3">
 			<description><![CDATA[Only updated once every 'perfperiod' steps!]]></description>
@@ -6376,5 +6407,5 @@
 			<description><![CDATA[Displays a guess of the symmetry plane (may take a long time to compue for complex bodies).
 Use scripting and the ModelSymmetry class to compute symmetry accurately.
-Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Komosinski-and-Jaskowski-2008]]></description>
+Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Jaskowski-and-Komosinski-2008]]></description>
 		</element>
 	</type>
@@ -6454,5 +6485,5 @@
 			<description><![CDATA[Displays a guess of the symmetry plane (may take a long time to compue for complex bodies).
 Use scripting and the ModelSymmetry class to compute symmetry accurately.
-Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Komosinski-and-Jaskowski-2008]]></description>
+Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Jaskowski-and-Komosinski-2008]]></description>
 		</element>
 	</type>
@@ -6464,10 +6495,15 @@
 		</element>
 		<element name="wrldmap" type="string">
-			<description><![CDATA[Description of the world (Type: Blocks or Heighfield). Enter
-   r <sizex> <sizey> [seed]
-to generate a random landscape, or
-   m <sizex> <sizey> digits
-   M <sizex> <sizey> numbers
-to provide height values.
+			<description><![CDATA[Description of the world (only applies to world types: "Blocks" or "Height field").
+To generate a random landscape, use:
+   r[scaling] <sizex> <sizey> [seed]
+To generate a custom landscape, provide height values:
+   m[scaling] <sizex> <sizey> digits...
+ or
+   M[scaling] <sizex> <sizey> numbers...
+
+"digits..." is a sequence of integer values 0,1,2,..,9. You may also use '-' and '|' characters for smooth slides between blocks.
+"numbers..." is a sequence of floating point values, so the "M" option provides more freedom.
+[scaling] is an optional linear scaling expression in the form of *FACTOR+OFFSET or *FACTOR-OFFSET, for example "r*0.1-2 5 5" creates a 5x5 random map with a 10% amplitude, shifted down by 2.
 
 See also the WorldMap object.]]></description>
@@ -7474,5 +7510,5 @@
 			<description><![CDATA[Displays a guess of the symmetry plane (may take a long time to compue for complex bodies).
 Use scripting and the ModelSymmetry class to compute symmetry accurately.
-Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Komosinski-and-Jaskowski-2008]]></description>
+Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Jaskowski-and-Komosinski-2008]]></description>
 		</element>
 	</type>